#!/bin/bash

################################### BLOCKATOR ########################################
################## Blokace a odblokovani uzivatelu VPN a Eduroam #####################

# Jmeno uzivatele (osetreno proti specialnim znakum).
printf -v username %q "$3"

# Server, konfiguracni soubor, hledany retezec a nazev sluzby pro restart.

### VPN ###
if [ $1 = "vpn" ]
then
	server1="vpn-server1"
	server2="vpn-server2" # Automaticky synchronizovano ze serveru vpn-server1
	config_file="/etc/freeradius/3.0/mods-config/files/authorize"
	search_string="#orionlogin Auth-Type = Reject # Blockator, neupravovat"
	service_cmd="/etc/init.d/freeradius restart"

### EDUROAM ###
elif [ $1 = "eduroam" ]
then
	server1="eduroam-server"
	server2="eduroam-server2" # Zmeny nutne aplikovat i na tomto serveru
	config_file="/etc/freeradius/users"
	search_string="#orionlogin Auth-Type := Reject # Blockator, neupravovat"
	service_cmd="/etc/init.d/freeradius restart"
fi


# Co se bude nahrazovat v promenne search_string (specialni znaky musi byt escapovany).
username_pattern="\#orionlogin"


### BLOKACE ###

if [ $2 = "block" ]
then
	replace_string=${search_string/$username_pattern/$username}"\n"$search_string
	action_cmd='sed -i "s/$search_string/$replace_string/g"'

### ODBLOKOVANI ###

elif [ $2 = "unblock" ]
then
  search_string=${search_string/$username_pattern/$username}
	replace_string=""
	action_cmd='sed -i "/^$search_string/d"'
fi


# Autentizace pro vstup na vzdalene servery.
kinit -k -t /var/www/blockator.zcu.cz/certificates/servisni-konto.keytab servisni-konto@ZCU.CZ

# Vykonani prikazu na vzdalenem serveru.
ssh root@$server1 /bin/bash << EOF
	cp $config_file $config_file.blockator.backup

	search_string='$search_string'
	replace_string='$replace_string'

#	echo "hleda se:        "\$search_string
#	echo "nahrazuje se za: "\$replace_string

	$action_cmd $config_file
	$service_cmd
EOF

if [ $1 = "eduroam" ]
then
  ssh root@$server2 /bin/bash << EOF
	cp $config_file $config_file.blockator.backup

	search_string='$search_string'
	replace_string='$replace_string'

#	echo "hleda se:        "\$search_string
#	echo "nahrazuje se za: "\$replace_string

	$action_cmd $config_file
	$service_cmd
EOF
fi