<hr>


<div class="loading-wrapper" id="loading-wrapper">
  <div class="spinner-border text-light" role="status">
    <span class="visually-hidden">Počkejte prosím&hellip;</span>
  </div>
  <p class="fs-5 text-light">Počkejte prosím&hellip;</p>
</div>


<?php if ($currentStep == 1): ?>


<form method="post" action="/portal/<?= $urlSection . '/' . (($action == ACT_EDIT) ? ACT_EDIT . '/' . $incident['id_incident'] : ''); ?>">
  <h3 class="mb-4">Založení incidentu</h3>

  <input type="hidden" name="csrf-token" value="<?= $csrfToken ?>">

  <div class="row">
    <?php $input = 'blocked-ip'; ?>
    <div class="col-xl-4 mb-3">
      <label for="<?= $formPrefix . $input ?>" class="form-label">IP adresa</label>
      <input type="text" class="form-control font-monospace" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" maxlength="<?= $inputsMaxLengths[$input] ?>" value="<?= $inputsValues[$input] ?>" required aria-describedby="<?= $input ?>Help">
      <div id="<?= $input ?>Help" class="form-text">IP adresa z&nbsp;rozsahu <span class="font-monospace"><?= IP_ORG_RANGE ?></span>, která se účastnila incidentu a&nbsp;podle níž se bude vyhledávat v&nbsp;logu.</div>
    </div>

    <?php $input = 'blocked-mac'; ?>
    <div class="col-xl-4 mb-3">
      <label for="<?= $formPrefix . $input ?>" class="form-label">MAC adresa (nepovinné)</label>
      <input type="text" class="form-control font-monospace" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" maxlength="<?= $inputsMaxLengths[$input] ?>" value="<?= $inputsValues[$input] ?>" aria-describedby="<?= $input ?>Help">
      <div id="<?= $input ?>Help" class="form-text">Fyzická MAC adresa zařízení, které se účastnilo incidentu a&nbsp;podle níž se bude vyhledávat v&nbsp;logu.</div>
    </div>
  </div>

  <?php $input = 'incident-datetime'; ?>
  <div class="mb-3">
    <label for="<?= $formPrefix . $input ?>" class="form-label">Datum a&nbsp;čas výskytu incidentu</label>
    <input type="text" class="form-control font-monospace" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" value="<?= $inputsValues[$input] ?>" required aria-describedby="<?= $input ?>Help">
    <div id="<?= $input ?>Help" class="form-text">Časová značka, kdy došlo k&nbsp;incidentu a&nbsp;podle níž se bude vyhledávat v&nbsp;logu. Vyplněný čas bude v&nbsp;případě uvedení jiného časového pásma převeden do časové zóny <i>Europe/Prague</i>.</div>
  </div>

  <?php $input = 'id-type'; ?>
  <div class="mb-3">
    <label for="<?= $formPrefix . $input ?>" class="form-label">Typ incidentu</label>
    <select class="form-select" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" aria-label="Výběr typu incidentu" required aria-describedby="<?= $input ?>Help">
      <option value="0">Vyberte&hellip;</option>
      <?php foreach ($types as $type): ?>
      <option value="<?= $type['id_incident_type'] ?>"<?= (($inputsValues[$input] == $type['id_incident_type']) ? ' selected': ''); ?>><?= $type['name'] ?></option>
      <?php endforeach; ?>
    </select>
    <div id="<?= $input ?>Help" class="form-text">Na základě typu incidentu budou vybrány šablony pro e-maily.</div>
  </div>

  <div class="row">
    <?php $input = 'id-parent-ticket'; ?>
    <div class="col-9 col-xs-14 col-md-12 col-lg-4 mb-3">
      <label for="<?= $formPrefix . $input ?>" class="form-label">Číslo lístku se stížností (nepovinné)</label>
      <input type="number" class="form-control" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" value="<?= $inputsValues[$input] ?>" onchange="initTicketBtn('<?= $formPrefix . $input ?>')" min="1" aria-describedby="<?= $input ?>Help">
      <div id="<?= $input ?>Help" class="form-text">Číslo lístku (ticketu) v&nbsp;RT systému, v&nbsp;němž je vedena stížnost. V&nbsp;případě nevyplnění nebude možné odeslat upozornění stěžovateli o&nbsp;vyřešení incidentu.</div>
    </div>

    <div class="col-7 col-xs-2 col-md-4 col-lg-4 col-xl-3 text-right mb-3">
      <label class="form-label d-block">&nbsp;</label>
      <a href="https://rt.zcu.cz/rt/" target="_blank" class="btn btn-outline-secondary" id="btn-<?= $input ?>">
        <span data-feather="eye"></span>
        Zobrazit
      </a>
    </div>
  </div>

  <script nonce="<?= HTTP_HEADER_CSP_NONCE ?>">
    function initTicketBtn(elementValueId) {
      let ticketValue = document.getElementById(elementValueId).value;

      if (ticketValue !== '') {
        document.getElementById('btn-<?= $input ?>').href = 'https://rt.zcu.cz/rt/Ticket/Display.html?id=' + ticketValue;
      }
    }

    initTicketBtn('<?= $formPrefix . $input ?>')
  </script>

  <?php if ($incidentLastStep <= 3): ?>
  <div class="text-center">
    <button type="submit" class="btn btn-primary btn-lg" name="<?= $formPrefix . $action; ?>" onclick="activateLoading()">
      <span data-feather="search"></span>
      Vyhledat
    </button>
  </div>
  <?php endif; ?>
</form>


<?php elseif ($currentStep == 2): ?>


<script>
  function verifyUsersCheckboxes() {
    let checkboxes = document.getElementsByName('incident-user[]');
    let countChecked = 0;

    for (let i = 0; i < checkboxes.length; i++) {
      if (checkboxes[i].checked) {
        countChecked++;
      }
    }

    if (countChecked > 1) {
      return confirm('Opravdu chcete v rámci identifikace vybrat více uživatelů? V každém incidentu lze zablokovat pouze jednoho uživatele.');
    }
  }
</script>

<form method="post" action="/portal/<?= $urlSection . '/' . (($action == ACT_EDIT) ? ACT_EDIT . '/' . $incident['id_incident'] : '') . '?step=' . $currentStep; ?>">
  <h3>Identifikace</h3>
  <p class="mb-4">Cílem identifikace je na základě IP adresy a&nbsp;časové značky uvedené ve stížnosti nalézt v&nbsp;logu konkrétního uživatele, popř. zařízení a&nbsp;identifikovat jeho správce.</p>

  <?php if ($incident['identifiedUsers'][0] == CSIRT_ABUSE_CONTACT): ?>
  <div class="alert alert-warning" role="alert">
    Pro danou IP adresu se nepodařilo dohledat konkrétního uživatele nebo lokálního správce!
  </div>
  <?php endif; ?>

  <input type="hidden" name="csrf-token" value="<?= $csrfToken ?>">

  <?php if (!empty($incident['identifiedUsers'])): ?>
  <div class="table-responsive">
    <table class="table table-striped table-hover align-middle">
      <thead>
      <tr>
        <th scope="col">E-mail</th>
        <th scope="col">Jméno a&nbsp;příjmení</th>
        <th scope="col">Detaily o&nbsp;uživateli</th>
        <th scope="col">Použitá IP adresa</th>
        <th scope="col">Hostname zařízení</th>
        <th scope="col">MAC adresa zařízení</th>
        <th scope="col">Síť</th>
      </tr>
      </thead>
      <tbody>
      <?php for ($i = 0; $i < count($incident['identifiedUsers']); $i++): ?>
        <?php $input = 'user'; ?>
        <tr>
          <td>
            <div class="form-check">
              <input type="checkbox" name="<?= $formPrefix . $input ?>[]" id="<?= $formPrefix . $input . $i ?>" value="<?= $incident['identifiedUsers'][$i] ?>"<?php if (count($incident['identifiedUsers']) == 1 || strpos($inputsValues['blocking-recipient'], $incident['identifiedUsers'][$i]) !== false) echo ' checked'; ?> class="form-check-input<?php if (count($incident['identifiedUsers']) == 1) echo ' d-none'; ?>">
              <label class="form-check-label" for="<?= $formPrefix . $input . $i ?>">
                <?php if (!empty($incident['identifiedUsers'][$i])): ?>
                <span data-feather="at-sign"></span>
                <span class="text-danger"><?= $incident['identifiedUsers'][$i] ?></span>
                <?php else: ?>
                &ndash;
                <?php endif; ?>
              </label>
            </div>
          </td>
          <td>
            <?php if (!empty($incident['user_detail'][$i])): ?>
            <span data-feather="user"></span>
            <?= $incident['user_detail'][$i] ?>
            <?php else: ?>
            &ndash;
            <?php endif; ?>
          </td>
          <td>
            <?php if (!empty($incident['user_detail'][$i])): ?>
            <a href="https://whois3.zcu.cz/web1/formServlet?login=<?= get_email_part($incident['identifiedUsers'][$i], 'username') ?>&amp;odeslat.x=0&amp;odeslat.y=0&amp;formular=~~" target="_blank" class="btn btn-sm btn-outline-secondary" role="button">
              <span data-feather="eye"></span> WhoIS
            </a>
            <?php else: ?>
            &ndash;
            <?php endif; ?>
          </td>
          <td>
            <span data-feather="hash"></span>
            <code style="color: purple"><?= $incident['blocked_ip'] ?></code>
          </td>
          <td>
            <?php if (!empty($incident['hostnames'][$i])): ?>
            <span data-feather="tag"></span>
            <code class="text-success"><?= $incident['hostnames'][$i] ?></code>
            <?php else: ?>
            &ndash;
            <?php endif; ?>
          </td>
          <td>
            <?php if (!empty($incident['macAddresses'][$i])): ?>
              <span data-feather="cpu"></span>
              <code class="text-primary"><?= $incident['macAddresses'][$i] ?></code>
            <?php else: ?>
            &ndash;
            <?php endif; ?>
          </td>
          <td>
            <span data-feather="globe"></span>
            <?= $incident['network'] ?>
          </td>
        </tr>
      <?php endfor; ?>
      </tbody>
    </table>
  </div>
  <?php endif; ?>

  <?php if (!empty($incident['incident_evidence'])): ?>
  <div class="mb-3">
    <label class="form-label">Záznamy nalezené v&nbsp;logu</label>
    <div class="form-control font-monospace text-secondary border-1 overflow-auto" style="height: 180px; font-size: .8rem"><?= $_incident['incident_evidence_formatted'] ?></div>
    <div class="form-text">Části z&nbsp;logů, v&nbsp;nichž byly nalezeny související záznamy o&nbsp;dané IP adrese v&nbsp;inkriminovaném datu a&nbsp;čase.</div>
  </div>
  <?php endif; ?>

  <?php $input = 'user-lang'; ?>
  <div class="row">
    <div class="col-8 mb-3">
      <label class="form-label">Jazyk komunikace s&nbsp;uživatelem</label><br>
      <?php foreach ($_incidentLanguages as $i => $lang): ?>
      <div class="form-check form-check-inline">
        <div class="form-check">
          <input type="checkbox" value="<?= $lang['lang'] ?>" id="<?= $formPrefix . $input . $i ?>" name="<?= $formPrefix . $input ?>[]" class="form-check-input"<?= ((in_array($lang['lang'], $inputsValues[$input])) ? ' checked': ''); ?>>
          <label class="form-check-label" for="<?= $formPrefix . $input . $i ?>">
            <?= $lang['symbol'] ?>&nbsp;(<?= $lang['lang'] ?>)
          </label>
        </div>
      </div>
      <?php endforeach; ?>
      <div id="<?= $input ?>Help" class="form-text">Na základě zvoleného jazyka budou importovány šablony pro e-maily pro komunikaci s&nbsp;uživatelem.</div>
    </div>

    <?php if ($incident['id_parent_ticket'] != null): ?>
    <?php $input = 'parent-ticket-lang'; ?>
    <div class="col-8 mb-3">
      <label class="form-label">Jazyk komunikace se stěžovatelem</label><br>
      <?php foreach ($_incidentLanguages as $i => $lang): ?>
      <div class="form-check form-check-inline">
        <div class="form-check">
          <input type="checkbox" value="<?= $lang['lang'] ?>" id="<?= $formPrefix . $input . $i ?>" name="<?= $formPrefix . $input ?>[]" class="form-check-input"<?= ((in_array($lang['lang'], $inputsValues[$input])) ? ' checked': ''); ?>>
          <label class="form-check-label" for="<?= $formPrefix . $input . $i ?>">
            <?= $lang['symbol'] ?>&nbsp;(<?= $lang['lang'] ?>)
          </label>
        </div>
      </div>
      <?php endforeach; ?>
      <div id="<?= $input ?>Help" class="form-text">Na základě zvoleného jazyka budou importovány šablony pro e-maily pro komunikaci se stěžovatelem.</div>
    </div>
    <?php endif; ?>
  </div>

  <?php if ($incidentLastStep <= 3): ?>
  <div class="text-center">
    <button type="submit" class="btn btn-primary btn-lg" name="<?= $formPrefix . $action; ?>" onclick="return verifyUsersCheckboxes()">
      <span data-feather="user-check"></span>
      Potvrdit identifikaci
    </button>
  </div>
  <?php endif; ?>
</form>


<?php elseif ($currentStep == 3): ?>

<form method="post" action="/portal/<?= $urlSection . '/' . (($action == ACT_EDIT) ? ACT_EDIT . '/' . $incident['id_incident'] : '') . '?step=' . $currentStep; ?>">
  <h3>Blokace</h3>
  <p class="mb-4">Blokace spočívá v zablokování již identifikovaného uživatele nebo zařízení. Společně s&nbsp;tím dojde k zaslání e-mailu zablokovanému uživateli, nebo správci zablokovaného zařízení.</p>

  <input type="hidden" name="csrf-token" value="<?= $csrfToken ?>">

  <div class="row">
    <?php $input = 'blocking-recipient'; ?>
    <div class="col-6 mb-3">
      <label for="<?= $formPrefix . $input ?>" class="form-label">E-mail příjemce zprávy o&nbsp;blokaci</label>
      <input type="text" class="form-control" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" value="<?= $inputsValues[$input] ?>" required aria-describedby="<?= $input ?>Help">
      <div id="<?= $input ?>Help" class="form-text">Další příjemce lze oddělovat symbolem <code>,</code> (čárka). Příjemci budou uvedeni jako žadatelé v&nbsp;RT systému.</div>
    </div>

    <?php $input = 'blocking-subject'; ?>
    <div class="col-8 mb-3">
      <label for="<?= $formPrefix . $input ?>" class="form-label">Předmět zprávy</label>
      <input type="text" class="form-control" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" value="<?= $inputsValues[$input] ?>" required aria-describedby="<?= $input ?>Help">
    </div>

    <?php if ($action == ACT_EDIT): ?>
    <div class="col-2 text-right mb-3">
      <label class="form-label d-block">Lístek v&nbsp;RT systému</label>
      <a href="https://rt.zcu.cz/rt/Ticket/Display.html?id=<?= $incident['id_child_ticket'] ?>" target="_blank" class="btn btn-outline-secondary">
        <span data-feather="eye"></span>
        RT <?= $incident['id_child_ticket'] ?>
      </a>
    </div>
    <?php endif; ?>
  </div>

  <?php $input = 'blocking-message'; ?>
  <div class="mb-3">
    <label for="<?= $formPrefix . $input ?>" class="form-label">Obsah zprávy</label>
    <textarea class="form-control" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" rows="10" required><?= $inputsValues[$input] ?></textarea>
  </div>

  <?php if ($incidentLastStep <= $currentStep): ?>
  <div class="text-center">
    <button type="submit" class="btn btn-primary btn-lg" name="<?= $formPrefix . $action; ?>" onclick="if (!confirm('Opravdu chcete uživatele zablokovat? Po odsouhlasení již nelze měnit data v předchozích krocích.')) return false; activateLoading()">
      <span data-feather="lock"></span>
      Odeslat upozornění a&nbsp;zablokovat
    </button>
  </div>
  <?php endif; ?>
</form>


<?php elseif ($currentStep == 4): ?>


<form method="post" action="/portal/<?= $urlSection . '/' . (($action == ACT_EDIT) ? ACT_EDIT . '/' . $incident['id_incident'] : '') . '?step=' . $currentStep; ?>">
  <h3>Upozornění stěžovatele</h3>
  <p class="mb-4">Upozorněním stěžovatele dojde k zaslání e-mailu organizaci, která incident nahlásila.</p>

  <input type="hidden" name="csrf-token" value="<?= $csrfToken ?>">

  <div class="row">
    <?php $input = 'notify-recipient'; ?>
    <div class="col-13 mb-3">
      <label for="<?= $formPrefix . $input ?>" class="form-label">E-mail stěžovatele</label>
      <input type="text" class="form-control" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" value="<?= $inputsValues[$input] ?>" readonly aria-describedby="<?= $input ?>Help">
      <div id="<?= $input ?>Help" class="form-text">E-mail stěžovatele (žadatele) z&nbsp;rodičovského lístku z&nbsp;RT systému. V&nbsp;případě několika žadatelů jsou další příjemci jsou odděleni symbolem <code>,</code> (čárka).</div>
    </div>

    <div class="col-3 text-right mb-3">
      <label class="form-label d-block">Lístek stěžovatele v&nbsp;RT systému</label>
      <a href="https://rt.zcu.cz/rt/Ticket/Display.html?id=<?= $inputsValues['id-parent-ticket'] ?>" target="_blank" class="btn btn-outline-secondary">
        <span data-feather="eye"></span>
        RT <?= $inputsValues['id-parent-ticket'] ?>
      </a>
    </div>
  </div>

  <?php $input = 'notify-message'; ?>
  <div class="mb-3">
    <label for="<?= $formPrefix . $input ?>" class="form-label">Obsah zprávy (nepovinné)</label>
    <textarea class="form-control" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" rows="10" aria-describedby="<?= $input ?>Help"><?= $inputsValues[$input] ?></textarea>
    <div id="<?= $input ?>Help" class="form-text">Pokud nebude obsah zprávy vyplněn, přijde stěžovateli pouze zpráva o&nbsp;vyřešení incidentu z&nbsp;RT systému.</div>
  </div>

  <?php if ($incidentLastStep <= $currentStep): ?>
  <div class="text-center">
    <button type="submit" class="btn btn-primary btn-lg" name="<?= $formPrefix . $action; ?>" onclick="activateLoading()">
      <span data-feather="mail"></span>
      Upozornit stěžovatele
    </button>
  </div>
  <?php endif; ?>
</form>


<?php elseif ($currentStep == 5): ?>


<form method="post" action="/portal/<?= $urlSection . '/' . (($action == ACT_EDIT) ? ACT_EDIT . '/' . $incident['id_incident'] : '') . '?step=' . $currentStep; ?>">
  <h3>Odblokování</h3>
  <p class="mb-4">Odblokování a&nbsp;zaslání e-mailu uživateli, popř. správci zablokovaného zařízení o&nbsp;úspěšném odblokování.</p>

  <input type="hidden" name="csrf-token" value="<?= $csrfToken ?>">

  <div class="row">
    <?php $input = 'blocking-recipient'; ?>
    <div class="col-14 mb-3">
      <label for="<?= $formPrefix . $input ?>" class="form-label">E-mail příjemce zprávy o&nbsp;odblokování</label>
      <input type="text" class="form-control" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" value="<?= $inputsValues[$input] ?>" required readonly aria-describedby="<?= $input ?>Help">
      <div id="<?= $input ?>Help" class="form-text">E-mail problémového uživatele (popř. e-mail lokálního správce) z&nbsp;kroku <i>Identifikace</i>, kterému mu byla v minulsti zaslána zpráva o&nbsp;blokaci (e-mail již nelze změnit).</div>
    </div>

    <div class="col-2 text-right mb-3">
      <label class="form-label d-block">Lístek v&nbsp;RT systému</label>
      <a href="https://rt.zcu.cz/rt/Ticket/Display.html?id=<?= $incident['id_child_ticket'] ?>" target="_blank" class="btn btn-outline-secondary">
        <span data-feather="eye"></span>
        RT <?= $incident['id_child_ticket'] ?>
      </a>
    </div>
  </div>

  <?php $input = 'unblocking-message'; ?>
  <div class="mb-3">
    <label for="<?= $formPrefix . $input ?>" class="form-label">Obsah zprávy</label>
    <textarea class="form-control" id="<?= $formPrefix . $input ?>" name="<?= $formPrefix . $input ?>" rows="10" required><?= $inputsValues[$input] ?></textarea>
  </div>

  <?php if ($incidentLastStep <= $currentStep): ?>
  <div class="text-center">
    <button type="submit" class="btn btn-primary btn-lg" name="<?= $formPrefix . $action; ?>" onclick="activateLoading()">
      <span data-feather="key"></span>
      Odblokovat
    </button>
  </div>
  <?php endif; ?>
</form>


<?php endif; ?>


<script>
  function activateLoading() {
    let allInputsFilled = true;

    document.querySelectorAll('[required]').forEach(function(i) {
      if (!allInputsFilled) {
        return;
      }

      if (!i.value) {
        allInputsFilled = false;
      }

      if (i.type === 'radio') {
        let radioValueCheck = false;

        document.querySelectorAll(`[name=${i.name}]`).forEach(function(r) {
          if (r.checked) {
            radioValueCheck = true;
          }
        })

        allInputsFilled = radioValueCheck;
      }
    })

    if (allInputsFilled) {
      document.getElementById('loading-wrapper').style.display = 'flex';
    }
  }
</script>